#!/usr/local/bin/perl
# Chat Touring
# Copyright (c) 1996 by Paul Burchard
# Distributed under the terms of the GNU Library General Public License

# CONFIG:
#
# Set $docBase to the absolute URL (including the trailing slash)
# of the directory where the Chat Touring HTML documents are located.
#
$docBase="http://www/chat/";

$logoString="Chat Touring";

# Parse FORM input (values of 'f', 's' explicitly used).
$query = $ENV{QUERY_STRING};
%formData = ();
foreach(split('&', $ENV{QUERY_STRING})) {
	($name, $value) = split('=', $_);
	$value =~ s!\+! !g; $value =~ s!%(..)!pack('c',hex($1))!eg;
    $formData{$name} = $value;                
}

# Reformat FORM input into PARAM and other SGML tags.
# Use SGML encoding for special characters.
$params = "";
foreach $name (keys %formData) {
	$value = $formData{$name};
	$name =~ s!\&!&amp;!go; $name =~ s!\"!&quot;!go; $name =~ s!\<!&lt;!go; $name =~ s!\>!&gt;!go;
	$value =~ s!\&!&amp;!go; $value =~ s!\"!&quot;!go; $value =~ s!\<!&lt;!go; $value =~ s!\>!&gt;!go;
	$params .= "<param name=\"ChaTour.$name\" value=\"$value\">";
}
if($formData{'s'} eq '' || $formData{'f'} eq '') {
	$pixHeight = (10 + 3)*int((12*5)/4) + 50;
} else {
	$pixHeight = ($formData{'s'} + 3)*int(($formData{'f'}*5)/4) + 50;
}

# Filter chat.html, inserting requested parameters
# while ignoring any defaults.
open(TEMPLATE, "<chat.html");
print "Content-type: text/html\n";
print "Expires: Mon, 01 Jan 1900 00:00:00 GMT\n";
print "\n";
while(<TEMPLATE>) {
	s!<head[^>]*>!<head><base href="$docBase">!igo;
	s!height\s*\=\s*[\"]?[0-9]*[\"]?!height=$pixHeight!igo;
	s!<param[^>]*>!!igo;
	s!(<applet[^>]*>)!\1$params!igo;
	print;
}

1;
