#!/usr/local/bin/perl
# Chat Touring
# Copyright (c) 1996 by Paul Burchard
# Distributed under the terms of the GNU Library General Public License

# CONFIG:
#
# Set $docBase to the absolute URL (including the trailing slash)
# of the directory where the Chat Touring HTML documents are located.
#
# Set $cgiBase similarly for the Chat Touring CGI scripts (or leave
# it blank if this directory is the same as $docBase).
#
# Set $cgiSuffix to the filename suffix (including leading period)
# required by your HTTP server for CGI scripts written in Perl.
#
$docBase="http://www/chat/";
$cgiBase="/cgi-bin/";
$cgiSuffix=".pl";

$logoString="Chat Touring";

# Parse FORM input (values of 'f', 's', 't', explicitly used).
$query = $ENV{QUERY_STRING};
%formData = ();
foreach(split('&', $ENV{QUERY_STRING})) {
	($name, $value) = split('=', $_);
	$value =~ s!\+! !g; $value =~ s!%(..)!pack('c',hex($1))!eg;
    $formData{$name} = $value;                
}

# Extract parameters to build FRAMESET.
$address = $formData{'t'};
if($address eq '') {
	$address = "help.html";
}
if($formData{'s'} eq '' || $formData{'f'} eq '') {
	$pixHeight = (10 + 4)*int((12*5)/4) + 75;
} else {
	$pixHeight = ($formData{'s'} + 4)*int(($formData{'f'}*5)/4) + 75;
}

# Deliver FRAMSET, which will call back chat.cgi to create chat window.
open(TEMPLATE, "<express.html");
print "Content-type: text/html\n";
print "Expires: Mon, 01 Jan 1900 00:00:00 GMT\n";
print "\n";
while(<TEMPLATE>) {
	s!<head[^>]*>!<head><base href="$docBase">!igo;
	s!rows\s*\=\s*[\"]?[0-9,*]*[\"]?!rows="$pixHeight,*"!igo;
	s!src\s*\=\s*[\"]?help\.html[\"]?!src="$address"!igo;
	s!src\s*\=\s*[\"]?chat\.html[\"]?!src="${cgiBase}chat${cgiSuffix}?${query}"!igo;
	print;
}

1;

